/*

Access to Posix sys/stat.h

*/

#define _POSIX_SOURCE 1

#ifndef _P_STAT_H_
#define _P_STAT_H_


#include "eiffel.h"
#include <sys/stat.h>


/* functions */

EIF_INTEGER posix_chmod(EIF_POINTER path, EIF_INTEGER mode);
EIF_INTEGER posix_fstat(EIF_INTEGER fildes, EIF_POINTER buf);
EIF_INTEGER posix_mkdir(EIF_POINTER path, EIF_INTEGER mode);
EIF_INTEGER posix_mkfifo(EIF_POINTER path, EIF_INTEGER mode);
EIF_INTEGER posix_stat(EIF_POINTER path, EIF_POINTER buf);
EIF_INTEGER posix_umask(EIF_INTEGER cmask);


/* constants */

EIF_INTEGER const_s_irgrp();
EIF_INTEGER const_s_iroth();
EIF_INTEGER const_s_irusr();

EIF_INTEGER const_s_isgid();
EIF_INTEGER const_s_isuid();

EIF_INTEGER const_s_iwgrp();
EIF_INTEGER const_s_iwoth();
EIF_INTEGER const_s_iwusr();

EIF_INTEGER const_s_ixusr();
EIF_INTEGER const_s_ixgrp();
EIF_INTEGER const_s_ixoth();

/* stat structure */

EIF_INTEGER posix_st_atime (struct stat *buf);
EIF_INTEGER posix_st_ctime (struct stat *buf);
EIF_INTEGER posix_st_dev (struct stat *buf);
EIF_INTEGER posix_st_gid (struct stat *buf);
EIF_INTEGER posix_st_ino (struct stat *buf);
EIF_INTEGER posix_st_mode (struct stat *buf);
EIF_INTEGER posix_st_mtime (struct stat *buf);
EIF_INTEGER posix_st_nlink (struct stat *buf);
EIF_INTEGER posix_st_size (struct stat *buf);
EIF_INTEGER posix_st_uid (struct stat *buf);

EIF_INTEGER posix_stat_size();


#endif /* _P_STAT_H_ */
