/*

General utility functions.

*/


#include "c_support.h"


/* bit operations */

EIF_INTEGER posix_and (EIF_INTEGER op1, EIF_INTEGER op2)
{
  return (op1 & op2);
}


EIF_INTEGER posix_not (EIF_INTEGER op)
{
  return (~ op);
}


EIF_INTEGER posix_or (EIF_INTEGER op1, EIF_INTEGER op2)
{
  return (op1 | op2);
}


/* read/write arbitrary bytes */

EIF_INTEGER posix_peek_byte(EIF_POINTER ptr, EIF_INTEGER index)
{
  return (((char *) ptr)[index]);
}


EIF_INTEGER posix_peek_integer(EIF_POINTER ptr, EIF_INTEGER index)
{
  return (((int *) ptr)[index]);
}


void posix_poke_byte(EIF_POINTER ptr, EIF_INTEGER index, EIF_INTEGER value)
{
  ((char *) ptr)[index] = value;
}


/* we need the Posix access routine... */

EIF_BOOLEAN is_windows()
{
#ifdef _WIN32
  return 1;
#else
  return 0;
#endif
}
